###########################################################################
#
#   Copyright (c) 2000,2001 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Erik Enge <erik@esol.no>
#	Copyright (c) 2000,2001 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.6 $

from Globals import HTMLFile
from Globals import Persistent
from Globals import MessageDialog
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.SimpleItem
import Products
import DateTime
import base_item
import string

manage_add_note_form = HTMLFile('note_add', globals())

def manage_add_note(self, id='', body='', creator='', REQUEST=None, RESPONSE=None):
	"Add an instance of the Note class."

	if not id:

		id = str(self.get_unique_id())

	if REQUEST is not None:

		author = REQUEST['AUTHENTICATED_USER'].getId()

	elif creator:

		author = creator

	else:

		author = ''

	self._setObject(id, note(id, body, author))

	if RESPONSE is not None:

		RESPONSE.redirect(self.absolute_url())

	else:

		return self[id]


class note(
	Products.ZCatalog.CatalogAwareness.CatalogAware,
	OFS.SimpleItem.Item,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"""Simple storage for a note."""

	use_local_navigation = 0

	meta_type = 'Note'
	icon = 'misc_/Notes/dtmldoc.gif'
	default_catalog = 'Catalog'

	_properties = (
		{'id':'body', 'type':'text'},
		)

	manage_options = (
		{'label':'Edit', 'action':'manage_main'},
		{'label':'View', 'action':''},
		)

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('View Notes',
		 ('',)),
		)

	index_html = HTMLFile('note_index', globals())


	def __init__(self, id, body='', author=''):
		"Initialize the class instance"

		self.id = id
		self.body = body
		self.author = author
		self.date_created = DateTime.DateTime()
		self.index_object()


	def name_title_or_id(self):
		"""Returns a string suitable in the breadcrumbs."""

		if len(self.body) > 15:

			return self.body[:15] + '...'

		else:

			if string.strip(self.body):

				return self.body

			else:

				return 'No body'


	def render_datetime(self):
		"""Returns a string representing the date and time this note was created/edited."""

		return "%s %s" % (self.date_created.Date(), self.date_created.TimeMinutes())


default__class_init__(note)

